<?php
/*
Plugin Name: Comment E-Mail Verification
Plugin URI: http://ten-fingers-and-a-brain.com/wordpress-plugins/comment-email-verify/
Version: 0.1
Description: If a comments is held for moderation an e-mail message is sent to the comment's author with a link to verify the comment author's e-mail address. When the comment author clicks on that link the comment gets approved immediately. This makes discussions more lively as users don't have to wait for the blog admin to approve the comment.
Author: Martin Lormes
Author URI: http://ten-fingers-and-a-brain.com/
Text Domain: comment-email-verify
*/

function comment_email_verify__action__comment_post ( $id, $status )
{
  if (0==$status) /** @todo don't do this for trackbacks and pingbacks */
  {
    $chars = '1234567890qwertzuiopasdfghjklyxcvbnm';
    $key = '';
    for($i=0;$i<6;$i++) $key .= substr ( $chars, rand ( 0, strlen ( $chars ) - 1 ), 1 );
    update_comment_meta($id,'comment_email_verify',$key);
    
    $comment = get_comment($id);
    $address = $comment->comment_author_email;
    
    $url = get_bloginfo('url')."/?comment_email_verify=$id+$key";
    
    // $post = get_post($comment->comment_post_ID);
    
    $subject = "[".get_bloginfo('name')."] Please verify your e-mail address";
    $message = "Please go to\n\n$url\n\nto verify your e-mail address";
    
    wp_mail($address,$subject,$message);
  }
}
add_action ( 'comment_post', 'comment_email_verify__action__comment_post', 10, 2 );

function comment_email_verify__action__init ()
{
  if ( 'GET' != $_SERVER['REQUEST_METHOD'] or empty ( $_GET['comment_email_verify'] ) ) return;
  
  $code = $_GET['comment_email_verify'];
  list ( $id, $key ) = explode ( ' ', $code, 2 );
  
  if ( get_comment_meta($id,'comment_email_verify',true) != $key ) wp_die ('something went wrong. your e-mail address was not verified.');
  
  $comment = get_comment($id);
  $status = $comment->comment_approved;
  if ( ! in_array($status,array(0,1,)) ) wp_die ('something went wrong. your e-mail address was not verified.');
  
    global $wpdb;
    $wpdb->update( $wpdb->comments, array('comment_approved' => 1), array('comment_ID' => $id) );
    
    delete_comment_meta($id,'comment_email_verify');
    
    clean_comment_cache($id);
    $comment = get_comment($id);
    wp_update_comment_count($comment->comment_post_ID);
    
    if ( get_option('comments_notify') ) wp_notify_postauthor($id, $comment->comment_type);
    
    wp_redirect(get_comment_link($id));
    exit;
}
add_action ( 'init', 'comment_email_verify__action__init' );
